/*

 SPC 00-0F Commands

*/

/* 00 */

SPC_NOP:
    movw %bx,PC
    jmp SPC_BACK

/* 01 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_0:
    TCALL 0
    jmp SPC_BACK

/* 02 */

SPC_SET0:
    SPC_SET 0
    jmp SPC_BACK

/* 03 */

SPC_BBS0:
    SPC_BBS 0
    jmp SPC_BACK

/* 04 */

SPC_OR_A_dp:
    SPC_OR_A dp
    jmp SPC_BACK

/* 05 */

SPC_OR_A_abs:
    SPC_OR_A ABS
    jmp SPC_BACK

/* 06 */

SPC_OR_A_OXO:
    SPC_OR_A OXO
    jmp SPC_BACK

/* 07 */

SPC_OR_A_OOdp_XOO:
    SPC_OR_A OOdp_XOO
    jmp SPC_BACK

/* 08 */

SPC_OR_A_IM:
    movw %bx,PC
    SPC_OR_A IM
    jmp SPC_BACK

/* 09 */

SPC_OR_dp_dp:
    SPC_ADDR_dp_dp      // %dl is source byte, %bx dest address
    GET_BYTE_SPC        // %al contains byte at dest address
    orb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 0A */

SPC_OR1:        // Carry flag = Carry flag OR mem.bit
    SPC_ADDR_membit     // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    jnc SPC_BACK        // C | 0 = C
    SET_FLAG_SPC (SPC_FLAG_C)   // C | 1 = 1
    jmp SPC_BACK

/* 0B */

SPC_ASL_dp:
    SPC_ASL dp
    jmp SPC_BACK

/* 0C */

SPC_ASL_abs:
    SPC_ASL ABS
    jmp SPC_BACK

/* 0D */

SPC_PUSH_PSW:
    movw %bx,PC
    SETUPFLAGS_SPC
    PUSH_B
    jmp SPC_BACK

/* 0E */

SPC_TSET1:          // I have done this as TSB (65816) including the flag setting based on AND
    SPC_ADDR_ABS
    GET_BYTE_SPC    // Get byte
    movb A,%dl
    testb %al,%dl   // NZ set for: mem & A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    orb %dl,%al
    SET_BYTE_SPC    // mem |= A
    jmp SPC_BACK

/* 0F */

/* BRK - Not yet implemented (maybe never) */
