/*

 SPC 30-3F Commands

*/

/* 30 */

SPC_BMI:
    movw %bx,PC
    SPC_ADDR_IM
    TEST_FLAG_SPC(SPC_FLAG_N)
    jz  SPC_BACK        // condition false
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* 31 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_3:
    TCALL 3
    jmp SPC_BACK

/* 32 */

SPC_CLR1:
    SPC_CLR 1
    jmp SPC_BACK

/* 33 */

SPC_BBC1:
    SPC_BBC 1
    jmp SPC_BACK

/* 34 */

SPC_AND_A_Odp_XO:
    SPC_AND_A Odp_XO
    jmp SPC_BACK

/* 35 */

SPC_AND_A_Oabs_XO:
    SPC_AND_A OABS_XO
    jmp SPC_BACK

/* 36 */

SPC_AND_A_Oabs_YO:
    SPC_AND_A OABS_YO
    jmp SPC_BACK

/* 37 */

SPC_AND_A_OOdpO_YO:
    SPC_AND_A OOdpO_YO
    jmp SPC_BACK

/* 38 */

SPC_AND_dp_IM:
    movw %bx,PC
    SPC_ADDR_dp_IM      // dl contains IM, %bx dp
    GET_BYTE_SPC
    andb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 39 */

SPC_AND_OXO_OYO:
    SPC_ADDR_OXO_OYO
    GET_BYTE_SPC
    andb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 3A */

SPC_INCW_dp:
    SPC_ADDR_dp
    GET_WORD_SPC        // get DP word
    movl %eax,%edx
    incw %dx
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    decw %bx
    movl %edx,%eax
    SET_WORD_SPC
    jmp SPC_BACK

/* 3B */

SPC_ROL_Odp_XO:
    SPC_ROL Odp_XO
    jmp SPC_BACK

/* 3C */

SPC_ROL_A:
    movw %bx,PC
    MAKE_FLAGS_SPC (SPC_MASK_C)
    movb A,%al
    adcb %al,%al
    movb %al,A
    STORE_FLAGS_SPC (SPC_MASK_N+SPC_MASK_Z+SPC_MASK_C)
    jmp SPC_BACK

/* 3D */

SPC_INC_X:
    movw %bx,PC
    incb X
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* 3E */

SPC_CMP_X_dp:
    SPC_CMP_X dp
    jmp SPC_BACK

/* 3F */

SPC_CALL:
    movb 1(%esi),%al
    movb 2(%esi),%ah
    movw %ax,PC
    addl $2,%ebx
    movl %ebx,%eax
    PUSH_W
    jmp SPC_BACK
