/*

 SPC 50-5F Commands

*/

/* 50 */

SPC_BVC:
    movw %bx,PC
    SPC_ADDR_IM
    TEST_FLAG_SPC(SPC_FLAG_V)
    jnz SPC_BACK        // condition true
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* 51 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_5:
    TCALL 5
    jmp SPC_BACK

/* 52 */

SPC_CLR2:
    SPC_CLR 2
    jmp SPC_BACK

/* 53 */

SPC_BBC2:
    SPC_BBC 2
    jmp SPC_BACK

/* 54 */

SPC_EOR_A_Odp_XO:
    SPC_EOR_A Odp_XO
    jmp SPC_BACK

/* 55 */

SPC_EOR_A_Oabs_XO:
    SPC_EOR_A OABS_XO
    jmp SPC_BACK

/* 56 */

SPC_EOR_A_Oabs_YO:
    SPC_EOR_A OABS_YO
    jmp SPC_BACK

/* 57 */

SPC_EOR_A_OOdpO_YO:
    SPC_EOR_A OOdpO_YO
    jmp SPC_BACK

/* 58 */

SPC_EOR_dp_IM:
    SPC_ADDR_dp_IM
    GET_BYTE_SPC
    xorb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 59 */

SPC_EOR_OXO_OYO:
    SPC_ADDR_OXO_OYO
    GET_BYTE_SPC
    xorb %dl,%al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
    jmp SPC_BACK

/* 5A */

SPC_CMPW_YA_dp:
    SPC_ADDR_dp
    movl YA,%edx
    GET_WORD_SPC        // get DP word
    cmpw %ax,%dx
    cmc
    // (0.30) Butcha: + C flag
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C)
    jmp SPC_BACK

/* 5B */

SPC_LSR_Odp_XO:
    SPC_LSR Odp_XO
    jmp SPC_BACK

/* 5C */

SPC_LSR_A:
    movw %bx,PC
    shrb $1,A
    STORE_FLAGS_SPC (SPC_MASK_C+SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* 5D */

SPC_MOV_X_A:
    movw %bx,PC
    movb A,%al
    testb %al,%al
    movb %al,X
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* 5E */

SPC_CMP_Y_abs:
    SPC_CMP_Y ABS
    jmp SPC_BACK

/* 5F */

SPC_JMP_abs:
    SPC_ADDR_ABS
    movw %bx,PC
    jmp SPC_BACK
