/*

 SPC 60-6F Commands

*/

/* 60 */

SPC_CLRC:
    movw %bx,PC
    CLR_FLAG_SPC (SPC_FLAG_C)
    jmp SPC_BACK

/* 61 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_6:
    TCALL 6
    jmp SPC_BACK

/* 62 */

SPC_SET3:
    SPC_SET 3
    jmp SPC_BACK

/* 63 */

SPC_BBS3:
    SPC_BBS 3
    jmp SPC_BACK

/* 64 */

SPC_CMP_A_dp:
    SPC_CMP_A dp
    jmp SPC_BACK

/* 65 */

SPC_CMP_A_abs:
    SPC_CMP_A ABS
    jmp SPC_BACK

/* 66 */

SPC_CMP_A_OXO:
    SPC_CMP_A OXO
    jmp SPC_BACK

/* 67 */

SPC_CMP_A_OOdp_XOO:
    SPC_CMP_A OOdp_XOO
    jmp SPC_BACK

/* 68 */

SPC_CMP_A_IM:
    movw %bx,PC
    SPC_CMP_A IM
    jmp SPC_BACK

/* 69 */

SPC_CMP_dp_dp:
    SPC_ADDR_dp_dp
    GET_BYTE_SPC
    cmpb %dl,%al
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C)
    jmp SPC_BACK

/* 6A */

SPC_AND1C:      // Carry flag = Carry flag AND !mem.bit
    SPC_ADDR_membit     // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC        // Get byte at location
    btl %edx,%eax
    jnc SPC_BACK        // C & ~0 = C
    CLR_FLAG_SPC (SPC_FLAG_C)   // C & ~1 = 0
    jmp SPC_BACK

/* 6B */

SPC_ROR_dp:
    SPC_ROR dp
    jmp SPC_BACK

/* 6C */

SPC_ROR_abs:
    SPC_ROR ABS
    jmp SPC_BACK

/* 6D */

SPC_PUSH_Y:
    movw %bx,PC
    movb Y,%al
    PUSH_B
    jmp SPC_BACK

/* 6E */

SPC_DBNZ_dp:
    SPC_ADDR_dp
    pushl %ebx
    GET_BYTE_SPC        // get (dp)
    movb %al,%dl        // %dl contains (dp)
    SPC_ADDR_IM
    GET_BYTE_SPC        // %al contains relative offset
    decb %dl
    jz 9f
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    cbw                 // sign extend for addition
    addw %ax,PC
9:  popl %ebx
    movb %dl,%al
    SET_BYTE_SPC
    jmp SPC_BACK

/* 6F */

SPC_RET:
    movw %bx,PC
    POP_W
    movl %eax,PC
    jmp SPC_BACK
