/*

 SPC 70-7F Commands

*/

/* 70 */

SPC_BVS:
    movw %bx,PC
    SPC_ADDR_IM
    TEST_FLAG_SPC(SPC_FLAG_V)
    jz  SPC_BACK        // condition false
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* 71 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_7:
    TCALL 7
    jmp SPC_BACK

/* 72 */

SPC_CLR3:
    SPC_CLR 3
    jmp SPC_BACK

/* 73 */

SPC_BBC3:
    SPC_BBC 3
    jmp SPC_BACK

/* 74 */

SPC_CMP_A_Odp_XO:
    SPC_CMP_A Odp_XO
    jmp SPC_BACK

/* 75 */

SPC_CMP_A_Oabs_XO:
    SPC_CMP_A OABS_XO
    jmp SPC_BACK

/* 76 */

SPC_CMP_A_Oabs_YO:
    SPC_CMP_A OABS_YO
    jmp SPC_BACK

/* 77 */

SPC_CMP_A_OOdpO_YO:
    SPC_CMP_A OOdpO_YO
    jmp SPC_BACK

/* 78 */

SPC_CMP_dp_IM:
    SPC_ADDR_dp_IM
    GET_BYTE_SPC
    cmpb %dl,%al
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C)
    jmp SPC_BACK

/* 79 */

SPC_CMP_OXO_OYO:
    SPC_ADDR_OXO_OYO
    GET_BYTE_SPC
    cmpb %dl,%al
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C)
    jmp SPC_BACK

/* 7A */

SPC_ADDW_YA_dp:
    SPC_ADDR_dp
    movl YA,%edx
    GET_WORD_SPC        // get DP word
    addw %ax,%dx
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:	SET_FLAG_SPC(SPC_FLAG_V)
2:	popf
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
    movl %edx,YA
    jmp SPC_BACK

/* 7B */

SPC_ROR_Odp_XO:
    SPC_ROR Odp_XO
    jmp SPC_BACK

/* 7C */

SPC_ROR_A:
    movw %bx,PC
    MAKE_FLAGS_SPC (SPC_MASK_C)
    movb A,%al
    rcrb $1,%al
    movb %al,A
    STORE_FLAGS_SPC (SPC_MASK_C)
    testb %al,%al
    STORE_FLAGS_SPC (SPC_MASK_N+SPC_MASK_Z)
    jmp SPC_BACK

/* 7D */

SPC_MOV_A_X:
    movw %bx,PC
    movb X,%al
    testb %al,%al
    movb %al,A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* 7E */

SPC_CMP_Y_dp:
    SPC_CMP_Y dp
    jmp SPC_BACK

/* 7F */

/* RETI - not yet implemented */
