/*

 SPC C0-CF Commands

*/

/* C0 */

SPC_DI:
    movw %bx,PC
    CLR_FLAG_SPC(SPC_FLAG_I)
    jmp SPC_BACK

/* C1 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_12:
    TCALL 12
    jmp SPC_BACK

/* C2 */

SPC_SET6:
    SPC_SET 6
    jmp SPC_BACK

/* C3 */

SPC_BBS6:
    SPC_BBS 6
    jmp SPC_BACK

/* C4 */

SPC_MOV_dp_A:
    SPC_MOV__A dp
    jmp SPC_BACK

/* C5 */

SPC_MOV_abs_A:
    SPC_MOV__A ABS
    jmp SPC_BACK

/* C6 */

SPC_MOV_OXO_A:
    SPC_MOV__A OXO
    jmp SPC_BACK

/* C7 */

SPC_MOV_OOdp_XOO_A:
    SPC_MOV__A OOdp_XOO
    jmp SPC_BACK

/* C8 */

SPC_CMP_X_IM:
    movw %bx,PC
    SPC_CMP_X IM
    jmp SPC_BACK

/* C9 */

SPC_MOV_abs_X:
    SPC_MOV__X ABS
    jmp SPC_BACK

/* CA */

SPC_MOV1__C:        // mem.bit = Carry flag
    SPC_ADDR_membit     // %bx contains mem and %dx contains bit number
    GET_BYTE_SPC
    TEST_FLAG_SPC (SPC_FLAG_C)
    jz  0f
    btsl %edx,%eax
    SET_BYTE_SPC
    jmp SPC_BACK
0:  btrl %edx,%eax
    SET_BYTE_SPC
    jmp SPC_BACK

/* CB */

SPC_MOV_dp_Y:
    SPC_MOV__Y dp
    jmp SPC_BACK

/* CC */

SPC_MOV_abs_Y:
    SPC_MOV__Y ABS
    jmp SPC_BACK

/* CD */

SPC_MOV_X_IM:
    movw %bx,PC
    SPC_MOV_X_ IM
    jmp SPC_BACK

/* CE */

SPC_POP_X:
    movw %bx,PC
    POP_B
    movb %al,X
    jmp SPC_BACK

/* CF */

SPC_MUL:
    movw %bx,PC
    movb Y,%al
    mulb A
    movl %eax,YA
    testw %ax,%ax
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK
