/*

 SPC D0-DF Commands

*/

/* D0 */

SPC_BNE:
    movw %bx,PC
    SPC_ADDR_IM
    TEST_FLAG_SPC(SPC_FLAG_Z)
    jnz SPC_BACK        // condition true
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
    jmp SPC_BACK

/* D1 */

/* TCALL: Call through table in pageable 64-bytes of RAM */
SPC_TCALL_13:
    TCALL 13
    jmp SPC_BACK

/* D2 */

SPC_CLR6:
    SPC_CLR 6
    jmp SPC_BACK

/* D3 */

SPC_BBC6:
    SPC_BBC 6
    jmp SPC_BACK

/* D4 */

SPC_MOV_Odp_XO_A:
    SPC_MOV__A Odp_XO
    jmp SPC_BACK

/* D5 */

SPC_MOV_Oabs_XO_A:
    SPC_MOV__A OABS_XO
    jmp SPC_BACK

/* D6 */

SPC_MOV_Oabs_YO_A:
    SPC_MOV__A OABS_YO
    jmp SPC_BACK

/* D7 */

SPC_MOV_OOdpO_YO_A:
    SPC_MOV__A OOdpO_YO
    jmp SPC_BACK

/* D8 */

SPC_MOV_dp_X:
    SPC_MOV__X dp
    jmp SPC_BACK

/* D9 */

SPC_MOV_Odp_YO_X:
    SPC_MOV__X Odp_YO
    jmp SPC_BACK

/* DA */

SPC_MOV_dp_YA:
    SPC_ADDR_dp
    movl YA,%eax
    SET_WORD_SPC
    jmp SPC_BACK

/* DB */

SPC_MOV_Odp_XO_Y:
    SPC_MOV__Y Odp_XO
    jmp SPC_BACK

/* DC */

SPC_DEC_Y:
    movw %bx,PC
    decb Y
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* DD */

SPC_MOV_A_Y:
    movw %bx,PC
    movb Y,%al
    testb %al,%al
    movb %al,A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    jmp SPC_BACK

/* DE */

SPC_CBNE_Odp_XO:
//  SPC_ADDR_Odp_XO
    addl $2,%ebx
    movw %bx,PC
    movl SPC_PAGE,%ebx
    movb X,%dl
    movb 1(%esi),%bl    // get dp
    addb %dl,%bl

    GET_BYTE_SPC        // Get (dp)
    cmpb %al,A
    je SPC_BACK
    movsbl 2(%esi),%eax // sign extend for addition
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles
    addw %ax,PC
    jmp SPC_BACK

/* DF */

/* DAA - not yet implemented */
