/*

    SPC Macro stuff - because the SPC looks a nitemare without it!

    	Code By Savouy SnaX - yup another macro based chunk

*/

.macro SPC_SET bitnum
    SPC_ADDR_dp
    GET_BYTE_SPC    // Get (dp)
    orb $(1 << (\bitnum)),%al
    SET_BYTE_SPC
.endm

.macro SPC_CLR bitnum
    SPC_ADDR_dp
    GET_BYTE_SPC    // Get (dp)
    andb $~(1 << (\bitnum)),%al
    SET_BYTE_SPC
.endm

.macro SPC_BBS bitnum
    SPC_ADDR_dp
    GET_BYTE_SPC        // Get (dp)
    SPC_ADDR_IM
    andb $1<<(\bitnum),%al
    jz 9f               // bit clr - No branch
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
9:
.endm

.macro SPC_BBC bitnum
    SPC_ADDR_dp
    GET_BYTE_SPC        // Get (dp)
    SPC_ADDR_IM
    andb $1<<(\bitnum),%al
    jnz 9f              // bit set - No branch
    subl $2,%ebp        // Branch taken
    addl $2,TotalCycles    // (0.32) Butcha - fix 'lost' SPC timer ticks!
    GET_BYTE_SPC
    cbw                 // sign extend for addition
    addw %ax,PC
9:
.endm

.macro SPC_OR_A addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    orb %al,A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
.endm

.macro SPC_AND_A addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    andb %al,A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
.endm

.macro SPC_EOR_A addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    xorb %al,A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
.endm

.macro SPC_CMP reg addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    cmpb %al,\reg
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C)
.endm

.macro SPC_CMP_A addr
    SPC_CMP A,\addr
.endm

.macro SPC_CMP_X addr
    SPC_CMP X,\addr
.endm

.macro SPC_CMP_Y addr
    SPC_CMP Y,\addr
.endm

.macro SPC_ADC_A addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    pushl %eax
    MAKE_FLAGS_SPC (SPC_MASK_C)
    popl %eax
    adcb %al,A
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:  SET_FLAG_SPC(SPC_FLAG_V)
2:  popf
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
.endm

.macro SPC_SBC_A addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    pushl %eax
    MAKE_FLAGS_SPC_INV (SPC_MASK_C)
    popl %eax
    sbbb %al,A
    pushf
    jo 1f
    CLR_FLAG_SPC(SPC_FLAG_V)    // Done cos STORE_FLAGS cant alter V!
    jmp 2f
1:  SET_FLAG_SPC(SPC_FLAG_V)
2:  popf
    cmc
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N+SPC_MASK_C+SPC_MASK_H)
.endm

.macro SPC_DEC addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    decb %al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
.endm

.macro SPC_INC addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    incb %al
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
.endm

.macro SPC_ASL addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    addb %al,%al
    STORE_FLAGS_SPC (SPC_MASK_C+SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
.endm

.macro SPC_LSR addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    shrb $1,%al
    STORE_FLAGS_SPC (SPC_MASK_C+SPC_MASK_Z+SPC_MASK_N)
    SET_BYTE_SPC
.endm

.macro SPC_ROL addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    movb %al,%dl
    MAKE_FLAGS_SPC (SPC_MASK_C)
    adcb %dl,%dl
    STORE_FLAGS_SPC (SPC_MASK_C+SPC_MASK_Z+SPC_MASK_N)
    movb %dl,%al
    SET_BYTE_SPC
.endm

.macro SPC_ROR addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    movb %al,%dl
    MAKE_FLAGS_SPC (SPC_MASK_C)
    rcrb $1,%dl
    STORE_FLAGS_SPC (SPC_MASK_C)
    testb %dl,%dl
    STORE_FLAGS_SPC (SPC_MASK_N+SPC_MASK_Z)
    movb %dl,%al
    SET_BYTE_SPC
.endm

.macro SPC_MOV__A addr
    SPC_ADDR_\addr
    movb A,%al
    SET_BYTE_SPC
.endm

.macro SPC_MOV__X addr
    SPC_ADDR_\addr
    movb X,%al
    SET_BYTE_SPC
.endm

.macro SPC_MOV__Y addr
    SPC_ADDR_\addr
    movb Y,%al
    SET_BYTE_SPC
.endm

.macro SPC_MOV_A_ addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    testb %al,%al
    movb %al,A
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
.endm

.macro SPC_MOV_X_ addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    testb %al,%al
    movb %al,X
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
.endm

.macro SPC_MOV_Y_ addr
    SPC_ADDR_\addr
    GET_BYTE_SPC
    testb %al,%al
    movb %al,Y
    STORE_FLAGS_SPC (SPC_MASK_Z+SPC_MASK_N)
.endm

.macro TCALL vecnum
    movl %ebx,%eax
    PUSH_W
    movw SPCRAM+0xFFC0+((15 - (\vecnum)) << 1),%ax
    movw %ax,PC
.endm
